﻿var h1s = $('h1');
var nav = $('nav');
nav.append('<p id="contentsHeader">CONTENTS</p>');
nav.append('<ul id="contents"></ul>');
var contentsRoot = $('nav ul');

if(h1s.length > 0)
	addHeaderEntries(contentsRoot, h1s, 1, 2, "");
	
$.each($('section'), function()
{
	var $this = $(this);
	$this.append('<a class="backToContents" href="#contents">Zurück zum Inhaltsverzeichnis.</a>');
	
	$('<div>', {
		class: 'spacer20mm'
	}).prependTo($this);
});

function addHeaderEntries(rootElement, headerElements, thisLevel, lowerLevel, number)
{
	$.each(headerElements, function()
	{ 
		var tmpNumber = getHeadlineNumber(number, $(this), headerElements);
		addListElement($(this), rootElement);
		var uuid = createUUID();
		var addedLink = rootElement.find('a').last();
		var addedSpan = rootElement.find('span').last();
		addAnker($(this), addedLink, uuid);
		addNumber($(this), addedSpan, tmpNumber);
		var innerHeadlineElements = getLowerLevelHeadlines($(this), thisLevel, lowerLevel);

		if(innerHeadlineElements.length > 0)
			addNextLevelEntries(rootElement, innerHeadlineElements, thisLevel, lowerLevel, tmpNumber);
	});
}

function addListElement(thisElement, rootElement)
{
	var listItemHTML = createListItem(thisElement);
	rootElement.append(listItemHTML);	
}

function createListItem(heading, number)
{
	return '<li><span class="tocText">' + heading.text() + '</span><a class="tocLink" href="#">' + ">>>>>>>>>" + '</a></li>';
}

function addAnker(heading, link, uuid)
{
	heading.attr('id', uuid);
	link.attr('href', '#' + uuid);
}

function createUUID()
{
	return uuid.v4(uuid.rng);
}

function getHeadlineNumber(number, heading, headerElements)
{
	var index = headerElements.index(heading) + 1;
	number += index + ".";
	return number;
}

function addNumber(heading, link, number)
{
	heading.text(number + " " + heading.text());
	link.text(number + " " + link.text());
}

function getLowerLevelHeadlines(currentHeaderElement, thisLevel, lowerLevel)
{
	var thisLevelTag = 'h' + thisLevel;
	var lowerLevelTag = 'h' + lowerLevel;
	
	return currentHeaderElement
		.nextUntil(thisLevelTag)
		.filter(lowerLevelTag);
}

function addNextLevelEntries(rootElement, innerHeadlineElements, thisLevel, lowerLevel, number)
{
	var lastLi = rootElement
		.children()
		.last('li');
					
	lastLi.append('<ul></ul>');
	
	var tempList = lastLi
		.find('ul').last();
		
	addHeaderEntries(tempList, innerHeadlineElements, ++thisLevel, ++lowerLevel, number);
}